diff --git a/arch/arm/mach-omap1/htc-bt.c b/arch/arm/mach-omap1/htc-bt.c
new file mode 100644
index 0000000..2e748ba
--- /dev/null
+++ b/arch/arm/mach-omap1/htc-bt.c
@@ -0,0 +1,183 @@
+/*
+ * Bluetooth built-in chip control
+ *
+ * Copyright (c) 2010 Cory Maccarrone
+ * Based on tosa-bt.c copyright (c) 2008 Dmitry Baryshkov
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/gpio.h>
+#include <linux/delay.h>
+#include <linux/rfkill.h>
+#include <linux/clk.h>
+
+#include <plat/mux.h>
+
+#include <mach/htc-bt.h>
+
+static struct clk *uart_ck;
+
+static void htc_bt_on(struct htc_bt_data *data)
+{
+	gpio_set_value(data->gpio_pwr, 1);
+
+	if (uart_ck)
+		clk_enable(uart_ck);
+
+	mdelay(1000);
+
+	if (data->gpio_enable)
+		gpio_set_value(data->gpio_enable, 1);
+}
+
+static void htc_bt_off(struct htc_bt_data *data)
+{
+	gpio_set_value(data->gpio_pwr, 0);
+
+	if (uart_ck)
+		clk_disable(uart_ck);
+
+	mdelay(1000);
+
+	if (data->gpio_enable)
+		gpio_set_value(data->gpio_enable, 0);
+}
+
+static int htc_bt_set_block(void *data, bool blocked)
+{
+	if (!blocked)
+		htc_bt_on(data);
+	else
+		htc_bt_off(data);
+
+	return 0;
+}
+
+static const struct rfkill_ops htc_bt_rfkill_ops = {
+	.set_block = htc_bt_set_block,
+};
+
+static int htc_bt_probe(struct platform_device *dev)
+{
+	int rc;
+	struct rfkill *rfk;
+
+	struct htc_bt_data *data = dev->dev.platform_data;
+
+	/* Configure the GPIOs */
+	if (data->gpio_enable) {
+		rc = gpio_request(data->gpio_enable, "Bluetooth enable");
+		if (rc)
+			goto err_enable;
+		rc = gpio_direction_output(data->gpio_enable, 0);
+		if (rc)
+			goto err_enable_dir;
+	}
+
+	rc = gpio_request(data->gpio_pwr, "Bluetooth power");
+	if (rc)
+		goto err_pwr;
+	rc = gpio_direction_output(data->gpio_pwr, 0);
+	if (rc)
+		goto err_pwr_dir;
+
+	/* Get the clocks */
+	if (data->uart_clock != NULL) {
+		uart_ck = clk_get(NULL, data->uart_clock);
+		if (IS_ERR(uart_ck)) {
+			pr_warn("htc-bt: Could not get uart clock\n");
+			uart_ck = NULL;
+		} else
+			clk_disable(uart_ck);
+	} else
+		uart_ck = NULL;
+
+	/* MUX pins for UART */
+	omap_cfg_reg(UART_7XX_1);
+	omap_cfg_reg(UART_7XX_2);
+
+	/* Configure RFKill */
+	rfk = rfkill_alloc("htc-bt", &dev->dev, RFKILL_TYPE_BLUETOOTH,
+			   &htc_bt_rfkill_ops, data);
+	if (!rfk) {
+		rc = -ENOMEM;
+		goto err_rfk_alloc;
+	}
+
+	rfkill_set_led_trigger_name(rfk, "htc-bt");
+
+	rc = rfkill_register(rfk);
+	if (rc)
+		goto err_rfkill;
+
+	platform_set_drvdata(dev, rfk);
+
+	return 0;
+
+err_rfkill:
+	rfkill_destroy(rfk);
+err_rfk_alloc:
+	htc_bt_off(data);
+err_pwr_dir:
+	gpio_free(data->gpio_pwr);
+err_pwr:
+err_enable_dir:
+	if (data->gpio_enable)
+		gpio_free(data->gpio_enable);
+err_enable:
+	return rc;
+}
+
+static int __devexit htc_bt_remove(struct platform_device *dev)
+{
+	struct htc_bt_data *data = dev->dev.platform_data;
+	struct rfkill *rfk = platform_get_drvdata(dev);
+
+	platform_set_drvdata(dev, NULL);
+
+	if (rfk) {
+		rfkill_unregister(rfk);
+		rfkill_destroy(rfk);
+	}
+	rfk = NULL;
+
+	htc_bt_off(data);
+
+	gpio_free(data->gpio_pwr);
+	if (data->gpio_enable)
+		gpio_free(data->gpio_enable);
+
+	return 0;
+}
+
+static struct platform_driver htc_bt_driver = {
+	.probe = htc_bt_probe,
+	.remove = __devexit_p(htc_bt_remove),
+
+	.driver = {
+		.name = "htc-bt",
+		.owner = THIS_MODULE,
+	},
+};
+
+
+static int __init htc_bt_init(void)
+{
+	return platform_driver_register(&htc_bt_driver);
+}
+
+static void __exit htc_bt_exit(void)
+{
+	platform_driver_unregister(&htc_bt_driver);
+}
+
+late_initcall(htc_bt_init);
+module_exit(htc_bt_exit);
+
diff --git a/arch/arm/mach-omap1/include/mach/htc-bt.h b/arch/arm/mach-omap1/include/mach/htc-bt.h
new file mode 100644
index 0000000..843ec45
--- /dev/null
+++ b/arch/arm/mach-omap1/include/mach/htc-bt.h
@@ -0,0 +1,22 @@
+/*
+ * HTC bluetooth built-in chip control.
+ *
+ * Copyright (C) 2010 Cory Maccarrone
+ * Based on tosa_bt.h copyright (c) 2008 Dmitry Baryshkov
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ */
+#ifndef HTC_BT_H
+#define HTC_BT_H
+
+struct htc_bt_data {
+	const char	*uart_clock;
+	int		gpio_pwr;
+	int		gpio_enable;
+};
+
+#endif
+